Ruby - Feature #11258

add 'x' mode character for O_EXCL
06/13/2015 01:06 PM - cremno (cremno phobia)

Status: Closed

Priority: Normal

Assignee: znz (Kazuhiro NISHIYAMA)
Target version:

Description
| just saw #11253 which contains:

But some modes has only integer form like O_CLOEXEC, O_EXCL.

However C11 added x to open a file for exclusive access. It's also supported by Python.

http://port70.net/~nsz/c/c11/n1570.html#7.21.5.3p5
https://docs.python.org/3.3/library/functions.html#open

Related issues:
Has duplicate Ruby - Feature #14007: open mode X' to raise error if file exists Closed

Associated revisions

Revision 842b735979f41169900af88a50e24d0d5e698a44 - 08/09/2018 08:49 AM - znz (Kazuhiro NISHIYAMA)
add 'x' mode character for O_EXCL

[Feature #11258]
Patch by cremno (cremno phobia)

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@64245 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 842b735979f41169900af88a50e24d0d5e698a44 - 08/09/2018 08:49 AM - znz (Kazuhiro NISHIYAMA)
add 'x' mode character for O_EXCL

[Feature #11258]
Patch by cremno (cremno phobia)

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@64245 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 842b7359 - 08/09/2018 08:49 AM - znz (Kazuhiro NISHIYAMA)
add 'x' mode character for O_EXCL

[Feature #11258]
Patch by cremno (cremno phobia)

git-svn-id: svn+ssh:/ci.ruby-lang.org/ruby/trunk@64245 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 06/16/2015 07:46 PM - cremno (cremno phobia)
- File excl_mode_v1.diff added

Here is a preliminary patch that passes make test-all (except for some RubyGems/SSL tests) on a glibc-based Linux (but | think some less common
code might not work anymore on Windows and other platforms that don't implement x but validate the mode string). Also rb_io_oflags_modestr()
didn't differentiate between w+ and r+ before - was that intended?

#2 - 06/16/2015 07:58 PM - normalperson (Eric Wong)
cremno@mail.ru wrote:

Issue #11258 has been updated by cremno phobia.

File excl_mode_v1.diff added
Here is a preliminary patch that passes make test-all (except for

some RubyGems/SSL tests) on a glibc-based Linux (but | think some less
common code might not work anymore on Windows and other platforms that
don't implement x but validate the mode string).

Haven't tested, but | like this feature for consistency with glibc
and Python.
Also rb_io_oflags_modestr() didn't differentiate between w+ and r+

before - was that intended?

I hope not, but it may also be too late to change without breaking
existing code and causing major data loss...

#3 - 06/16/2015 08:58 PM - normalperson (Eric Wong)

Eric Wong normalperson@yhbt.net wrote:

cremno@mail.ru wrote:

Also rb_io_oflags_modestr() didn't differentiate between w+ and r+
before - was that intended?

| hope not, but it may also be too late to change without breaking
existing code and causing major data loss...

Scratch that. | misremembered what rb_io_oflags_modestr did :x

#4 - 06/17/2015 04:16 AM - nobu (Nobuyoshi Nakada)

+#define MODE_BINARY_EXCL(a,b,c,d) \
+ ((oflags & O_EXCL) ? MODE_BINARY (d, c) : MODE_BINARY (b, a))
'a’, 'b' and 'c', 'd" are inverted?
#5 - 07/28/2015 07:35 AM - matz (Yukihiro Matsumoto)
It looks good to me.
Matz.
#6 - 07/29/2015 06:43 PM - cremno (cremno phobia)
- File excl_mode_v2.diff added
Nobuyoshi Nakada wrote:
+#define MODE_BINARY_EXCL(a,b,c,d) \
+ ((oflags & O_EXCL) ? MODE_BINARY (d, c) : MODE_BINARY (b, a))

'a’, 'b"and 'c', 'd' are inverted?

Yes, MODE_BINARY confused me (it uses it arguments in reverse order). | think MODE_BINARY_EXCL is a bad idea anyway. In V2 an
ArgumentError is raised by rb_io_oflags_modestr() when O_EXCL is set. This also affects the related flags: File::EXCL feature.
$stdout.reopen('stdout’, 'w', flags: File::EXCL) does now raise as it should since freopen() might not support x which could cause the truncation of an
existing file! That might not be the best solution though.

V2 also contains documentation and a news entry.

#7 - 10/13/2017 12:50 AM - shyouhei (Shyouhei Urabe)

- Has duplicate Feature #14007: open mode 'x' to raise error if file exists added

#8 - 08/09/2018 06:11 AM - ko1 (Koichi Sasada)
- Assignee set to znz (Kazuhiro NISHIYAMA)

07/18/2025 2/3


mailto:normalperson@yhbt.net
mailto:cremno@mail.ru

#9 - 08/09/2018 08:49 AM - znz (Kazuhiro NISHIYAMA)
- Status changed from Open to Closed

Applied in changeset trunk|r64245.

add 'x' mode character for O_EXCL

[Feature #11258]
Patch by cremno (cremno phobia)

Files
excl_mode_v1.diff 3.46 KB 06/16/2015 cremno (cremno phobia)
excl_mode_v2.diff 4.41 KB 07/29/2015 cremno (cremno phobia)
